#include <stdio.h>
#include <aalib.h>
#include <signal.h>

#include <vgakeyboard.h>


int has_console;
char *keytable;

aa_context *context;

char ev[100];
int ev_top;

unsigned char *bmp;

aa_renderparams rende = {
	0x80, 0x80,	/* bright, contrast */
	1.4, 		/* gama */
	AA_FLOYD_S,	/* dither */
	0, 		/* inversion */
	0,		/* random_val */
};

void
signal_int(int sig)
{
	aa_close(context);
	if( has_console )
	{
		keyboard_close();
	}

	printf("konec filma\n");
	exit(-1);
} /* singal_int */

int imgwidth;
int imgheight;

void
vline(aa_context *c, int l, int col)
{
	int i;


	signal(SIGINT, signal_int);

	for(i=aa_imgwidth(c); i--; )
	{
		aa_putpixel(c, i, l, col);
	}
} /* vline */

int
main()
{
	int i;
	int ch, ch_last;

	context = aa_autoinit(&aa_defparams);
	aa_autoinitkbd(context, AA_SENDRELEASE);

	 
	if( -1 ==  keyboard_init() )
	{
		has_console = 0;
	}
	else
	{
		keytable = keyboard_getstate();
		has_console = 1;
	}


	if(context == NULL) {
		fprintf(stderr, "Cannot initialize AA-lib. Sorry\n");
		exit(1);
	}

	bmp = aa_image(context);

	imgwidth = aa_imgwidth(context);
	imgheight = aa_imgheight(context);

	  
	for(i = 3; i ; i = (i+1) % imgheight ) 
	{

		vline(context, i - 1, 0); 
		vline(context, i, 100 ); 

		aa_render(
			context, &rende,
			0, 4, aa_scrwidth(context), aa_scrheight(context));

		ch_last = 0;
		if( has_console )
		{
#define KP(a) (keytable[(a)]?"x":"-")
			keyboard_update();
			

			aa_printf(context, 0, 0, 0,
				"line: %2i, asdfg:[%s%s%s%s]",
				i,
				KP(SCANCODE_A),
				KP(SCANCODE_S),
				KP(SCANCODE_D),
				KP(SCANCODE_F));
			
		}

#if 0
		ev_top = 0;
		{
			ch = aa_getevent(context, 0);
			ev[ev_top++] = ch & 0xff;
			//if(ev_top > 40 ) break;
		}while(ch != AA_NONE)
		ch = ch_last;

		aa_printf(context, 0, 0, 0,
			"line:%2i keys:%i(%s                 \n",
			i, ev_top, ev);

#endif

		aa_flush(context);

		usleep(10000L);
		//sleep(1);
	}


	if( has_console )
	{
		keyboard_close();
	}

	aa_close(context);
	return 0;
} /* main */

