#include <aalib.h>
#include <sys/time.h>
#include <unistd.h>
#include <assert.h>
#include <string.h>
#include <vgakeyboard.h>
#include "jp.h"

void jp_draw_background();
void jp_draw_foreground();
void jp_redraw();

void main_loop_move();
void main_loop_render();
void main_loop_sleep();

aa_renderparams jp_rendeopt = {
	0x20, 0x20,	/* bright, contrast */
	.4, 		/* gama */
	AA_ERRORDISTRIB,	/* dither */
	0, 		/* inversion */
	0,		/* random_val */
};

#if 0
	(sizeof(long long) !=  8 )
#error sizeof(long long) neni dost velka... (64 bych rad)
#endif

typedef long long int jp_time;

jp_time date_beg_uplne;
jp_time date_now;
jp_time date_beg_loop;
jp_time date_next_loop;

jp_time date_at_beg;
jp_time date_af_move;
jp_time date_af_render;
int loop_no = 0;
int must_render_in;


jp_time
main_loop_date()
{
	struct timeval tm;

	gettimeofday(&tm, NULL);

	date_now =  ((jp_time)tm.tv_sec) << 32 | ((jp_time)tm.tv_usec);

	return date_now;

} /* main_loop_date */

void
main_loop_next()
{
	date_beg_loop = date_next_loop;
	date_next_loop   += JP_PERIOD_LEN;
	loop_no++;
} /* date_next */


void
jp_main_loop()
{
	main_loop_date();

	date_beg_loop =
	date_beg_uplne = date_now;
	date_next_loop = date_beg_loop + JP_PERIOD_LEN;

	must_render_in = JP_MUST_RENDER_IN;

	main_loop_next();

	DB("main_loop");
	while(1)
	{
		/* 50 ms'ovy cyklus:    (JP_PERIOD_LEN)
		 *   5 ms move world    (JP_PERIOD_MV)
		 *   20 ms draw         (JP_PERIOD_DRAW)
		 *   20 ms sleep        (JP_PERIOD_SLEEP)
		 * 
		 * kdy z prestane stihat  prestane sleepat
		 * kdyz ani pak nestiha vynecha draw
		 * az po 10 fms (period == 100ms)
		 *
		 * date_now
		 * date_start_period
		 * date_next_period
		 *    5  move
		 */

		date_at_beg = main_loop_date();

		main_loop_move();

		date_af_move = main_loop_date();

		if(
				must_render_in == 0 ||
				date_now < date_beg_loop + JP_PERIOD_RENDER_BF) 
		{
			must_render_in = JP_MUST_RENDER_IN;
			main_loop_render();
		}
		else
		{
			must_render_in--;
		}

		main_loop_date();

		if( date_now < date_beg_loop + JP_PERIOD_SLEEP_BF )
		{
			main_loop_sleep();
		}

		main_loop_next();
	}
} /* jp_main_loop */

void
main_loop_move()
{
		DB("main_loop: bf jp_keyupdate");
		jp_clear();

	jp_draw_background();

	jp_keyupdate();

	DB("main: bf obj_tik");

	assert(jp_jetpac);
	jp_jetpac->tik(jp_jetpac);

	DB("main: bf obj_draw");
	jp_redraw();
	obj_draw(jp_jetpac);

} /* main_loop_move */

void
main_loop_render()
{
	aa_renderpalette(
		context, jp_palette, &jp_rendeopt,
		0, 0, aa_scrwidth(context), aa_scrheight(context));

	jp_draw_foreground();

	DB("jp_main_loop: bf aa_flush");
	aa_flush(context);

	DB("jp_main_loop: bf usleep");
}
void
main_loop_sleep()
{
	usleep(10000L);
} /* jp_main_loop */



int
jp_keyupdate()
{
	int ch;

	memcpy(keytable_last, keytable, 256);

	if(has_vgalib)
	{
		keyboard_update();
		return 0;
	}
#define KDWN(a) if(keytable[SCANCODE_ ## a ])keytable[SCANCODE_ ## a]--
#define KCASE(a_ch, a) case a_ch: keytable[SCANCODE_ ## a] = 5; break

	KDWN(H);
	KDWN(J);
	KDWN(K);
	KDWN(L);


	do{
		ch = aa_getevent(context, 0);
		DB("jp_keyupdate:ev:%i", ch);
		switch(ch)
		{
		KCASE('h', H);
		KCASE('j', J);
		KCASE('k', K);
		KCASE('l', L);
		KCASE('q', Q);
		}
	}while(ch != AA_NONE && ch != AA_UNKNOWN);

	return 0;
} /* jp_keyupdate */

int jp_line_pozadi = 0;
void
jp_draw_background()
{

	jp_vline(context, jp_line_pozadi, 50); 

	jp_line_pozadi = (jp_line_pozadi+1)% jp_screen_h;

} /* jp_draw_background */

void
jp_draw_foreground()
{
#define KP(a) (keytable[(a)]?"x":"-")
		DB("jp_draw_foreground:bf print keypress");
			
		aa_printf(context, 0, 0, 0,
			"line: %2i, asdfg hjkl:[%s%s%s%s%s %s%s%s%s]",
			jp_line_pozadi,
			KP(SCANCODE_A),
			KP(SCANCODE_S),
			KP(SCANCODE_D),
			KP(SCANCODE_F),
			KP(SCANCODE_G),

			KP(SCANCODE_H),
			KP(SCANCODE_J),
			KP(SCANCODE_K),
			KP(SCANCODE_L)
			);
} /* jp_draw_foreground */

void
jp_redraw()
{
	t_obj *i;

	DB("jp_redraw");

	for(i = objset_fst(set_trava);i;i = objset_nxt(set_trava))
	{
		DB("jp_redraw:trava");
		obj_draw(i);
		//i->tik(i);
	}
} /* jp_redraw */

