#ifndef __JP_H
#define __JP_H

#include <aalib.h>

#define JP_PERIOD_LEN      50000
#define JP_PERIOD_RENDER_BF  40000
#define JP_PERIOD_SLEEP_BF  30000

/* prekreslovat alespon jednou za 4 loopy,  i kdyz nestiham */
#define JP_MUST_RENDER_IN   4

#define JP

extern aa_context *context;
extern int has_vgalib;
extern char * keytable;
extern char keytable_nahradni[256];
extern char keytable_last[256];
extern aa_palette jp_palette;
extern int jp_screen_w, jp_screen_h;
extern int jp_spz_top;
extern unsigned char *jp_screen;

enum e_obj {
	JP_JETPAC = 1<<16,
	JP_TRAVA  = 2<<16,
	JP_FIRE   = 3<<16,
	JP_WKFO   = 4<<16,
};

void jp_vline(aa_context *c, int l, int col);
int jp_init(int argc, char *argv[]);
int jp_keyupdate();
void jp_clear();
void jp_close();

#define DB jp_dbg
void jp_dbg(char *p, ...);

typedef struct t_ev {

	int mv;
} t_ev;

typedef struct t_obj
{
	int x, y, dx, dy;
	int ox, oy;
	int (*tik)(struct t_obj*);
	int spz;
} t_obj;

typedef struct t_objset
{
	int siz, top, cur;
	int num;
	int spz;
	t_obj **o;

} t_objset;

t_objset *objset_new();
void objset_add(t_objset *set, t_obj* o);
t_obj *objset_fst(t_objset *set);
t_obj *objset_nxt(t_objset *set);
void objset_del(t_objset *set);
void objset_del_spz(t_objset *set, int spz);

t_obj * obj_new();
void obj_draw(t_obj *o);
//void obj_tik(t_obj *o);

extern t_obj *jp_jetpac;

extern t_objset *set_fire;
extern t_objset *set_trava;
extern t_objset *set_wkfo;
extern t_objset *set_trava;
extern t_objset *set_all;

void jp_main_loop();

#endif
