#include <stdlib.h>
#include <aalib.h>
#include "jp.h"
#include <assert.h>
#include <vgakeyboard.h>
#define JP_OBJSET_SIZ 32

#define JP_HOR_DELTA 3

int obj_tik_jetpac(t_obj *o);
int obj_tik_trava(t_obj *o);
int obj_tik_wkfo(t_obj *o);
int obj_tik_fire(t_obj *o);

t_objset *set_all;
t_objset *set_wkfo;
t_objset *set_fire;
t_objset *set_trava;


void 
obj_draw(t_obj *o)
{
	int i, j;
	int xx, yy;
	int col;

	DB("obj_draw");

	if( o->dx == 0 || o->dy == 0 )
	{
		return;
	}
	DB(" x:%i, y:%i, dx:%i, dy:%i", o->x, o->y, o->dx, o->dy);

	for( i = o->dx; i--; )
	for( j = o->dy; j--; )
	{
		col =	(50*i)/o->dx + 
			(50*j)/o->dy;
		xx = (o->x + i) % jp_screen_w;
		yy = (o->y + j) % jp_screen_h;
		aa_putpixel(context, xx, yy, col);
	}
	DB("/obj_draw" );

} /* jp_draw */

int jp_spz_top=0;

t_obj *
obj_new(int spz)
{
	t_obj *ret;
	
	DB("obj_new:spz:%x", spz);

	ret = (t_obj*) malloc(sizeof(t_obj));
	ret->x = 0;
	ret->y = 0;
	ret->dx = 8;
	ret->dy = 8;

	ret->spz= spz | jp_spz_top;
	jp_spz_top ++;

	assert(jp_spz_top < 0x10000);

	ret->tik = obj_tik_jetpac;

#if 1

	/* FIXME: udelej na to nekaou konstantu a dej ji do jp.h */
	switch(spz & 0xff0000 )
	{
	case JP_FIRE:
		ret->tik = obj_tik_fire;
		objset_add(set_fire, ret);
		break;
	case JP_TRAVA:
		ret->tik = obj_tik_trava;
		objset_add(set_trava, ret);
		break;
	case JP_WKFO:
		ret->tik = obj_tik_wkfo;
		objset_add(set_wkfo, ret);
		break;
	case JP_JETPAC:
		ret->tik = obj_tik_jetpac;
		break;
	default:
		DB("obj_new: !!!!!!!!!!!!!!!!!!!!!! created unknown obj %x",
			spz);
	}

	objset_add(set_all, ret);
#endif
	return ret;
} /* obj_new */
	
int 
obj_tik_wkfo(t_obj *o) {return 0;}
int 
obj_tik_trava(t_obj *o) {return 0;}
int 
obj_tik_fire(t_obj *o) {return 0;}

int
obj_keymove(t_obj *o)
{
#define KEY(A) (keytable[SCANCODE_ ## A])

	o->ox = o->x;
	o->oy = o->y;

	DB("obj_tik");

	/* if( KEY(H)  && o->x - JP_HOR_DELTA >= 0 ) */
	if( KEY(H)  )
	{
		DB("obj_tik:h");
		o->x +=  jp_screen_w - JP_HOR_DELTA;
		o->x %= jp_screen_w;
	}
	if( KEY(J)  && o->y + o->dy  < jp_screen_h )
	{
		DB("obj_tik:j");
		o->y++;
	}
	if( KEY(K)  && o->y  > 0 )
	{
		DB("obj_tik:k");
		o->y--;
	}
	/* if( KEY(L)  && o->x + o->dx + JP_HOR_DELTA < jp_screen_w ) */
	if( KEY(L) )
	{
		DB("obj_tik:l");
		o->x+= JP_HOR_DELTA;
		o->x %= jp_screen_w;
	}
	if( KEY(Q)  )
	{
		jp_close();
	}
	return 1;
} /* keyboard_handle */


int
objset_has_in(t_objset *set, t_obj *o, int nx, int ny)
{
	t_obj *i;

	for(i = objset_fst(set); i; i = objset_nxt(set))
	{
		if(
			(	(nx   + o->dx >= i->x + jp_screen_w )  ||
				(nx   + o->dx >= i->x  &&
				 i->x + i->dx >= nx )
			) &&
			ny   + o->dy >= i->y &&
			i->y + i->dy >= ny )
		{ /* protinaji se */
			return 1;
		}
	}
	return 0;
} /* objset_has_in */

int
objset_mv_kam_poss(t_objset *set, t_obj *o, int nx, int ny)
{
	assert(objset_has_in(set, o, o->x, o->y));

	

	

	return 0;
} /* obj_move_kam_possible */


int 
obj_tik_jetpac(t_obj *o)
{
	int nx;
	obj_keymove(o);
#if 0
	if( objset_has_in(o, set_trava) )
	{ /* pozor narazils */

		/* zkusime: jet jen nahoru */
		nx = o->x;
		o->x = o->ox;

		if( objset_has_in(o, set_trava) )
		{	/* nopasaran: jen doleva */
			o->x = nx;
			o->y = o->oy;

			if( objset_has_in(o, set_trava) )
			{ /* zadny maliny: vse zpet */
				o->x = o->ox;
			}
		}
	}
#endif

	/* gravitace */

	return 0;
} /* obj_tik */


/*******************************
 *  objs set
 *
 */

t_objset *
objset_new()
{
	t_objset *ret;


	ret = (t_objset*)malloc(sizeof(t_objset));
	assert(ret);

	ret->o = (t_obj**)malloc(sizeof(t_obj*) * JP_OBJSET_SIZ);
	assert(ret);

	ret->siz = JP_OBJSET_SIZ;

	ret->top = 0;
	ret->cur = 0;
	ret->num = 0;
	ret->spz = 0;

	return ret;
} /* objset_new */


void
objset_add(t_objset *set, t_obj *o)
{
	int i;

	set->num++;

	for(i=set->top;i--;)
	{	/* neni nahodou volne misto? */
		if( ! set->o[i] )
		{
			set->o[i] = o;
			return;
		}
	}

	/* neni: pridej na konec */

	assert( set->top < set->siz );

	set->o[set->top++] = o;
} /* objset_add */

/*
 * inicializace prochazeni mnoziny obj
 */

t_obj *
objset_fst(t_objset *set)
{
	set->cur = 0;
	return objset_nxt(set);
} /* objset_fst */

/*
 *  nasledujici prvek mnoziny
 */
t_obj *
objset_nxt(t_objset *set)
{
	while(set->cur < set->top)
	{
		if( set->o[set->cur] )
		{
			return set->o[set->cur++];
		}
		set->cur++;
	}

	/* nenasli jsme kamo */
	return NULL;
} /* objset_nxt */

/*
 * vyhodi `nty' prvek z mnoziny
 */
void
objset_del_nty(t_objset *set, int nty)
{
	if( nty < set->top && set->o[nty])
	{
		set->num --;
		set->o[nty] = NULL;
		assert(nty >= 0);
	}

} /* objset_del */

/*
 * vyhodi aktualni prvek z mnoziny
 */
void
objset_del(t_objset *set)
{
	objset_del_nty(set, set->cur);
} /* objset_del */


/*
 * vyhodi obj s spz
 */
void
objset_del_spz(t_objset *set, int spz)
{
	int i;

	for(i = set->top;i--;)
	{
		if( set->o[i] && set->o[i]->spz == spz)
		{ /* nasel jsem hrisnika */
			objset_del_nty(set, i);
			return;
		}
	}

	/* nenasel jsem nic */
	DB("objset_del_spz: obj s spz%i not found", spz);

} /* objset_delspz */
